Merge remote-tracking branch 'origin/pr/264'
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8 # shellcheck disable=SC2001,SC2181
9
10 # error_handler {{{
11 error_handler() {
12    last_exit_code="$?"
13    last_bash_command="$BASH_COMMAND"
14    echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
15 last bash command: $last_bash_command"
16    ## Check if "bailout" function is available.
17    ## This is not the case in chroot-script.
18    if command -v bailout >/dev/null 2>&1; then
19       bailout 1
20    else
21       exit 1
22    fi
23 }
24
25 set -e
26 set -E
27 set -o pipefail
28 trap "error_handler" ERR
29 export -f "error_handler"
30 # }}}
31
32 # variables {{{
33 PN="$(basename "$0")"
34 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
35   VERSION="$(git --git-dir "$(dirname "$(command -v "$0")")"/.git describe | sed 's|^v||')"
36 else
37   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
38 fi
39 VERSION="${VERSION:-unknown}"
40 MNTPOINT="/mnt/debootstrap.$$"
41
42 # defaults
43 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
44 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
45 [ -n "$DEBCONF" ] || DEBCONF='yes'
46 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
47 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
48 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
49 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
50 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
51 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
52 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
53 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
54 [ -n "$FORCE" ] || FORCE=''
55 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
56 [ -n "$INITRD" ] || INITRD='yes'
57 [ -n "$INITRD_GENERATOR" ] || INITRD_GENERATOR='initramfs-tools'
58 [ -n "$INITRD_GENERATOR_OPTS" ] || INITRD_GENERATOR_OPTS=''
59 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
60 [ -n "$LOCALES" ] || LOCALES='yes'
61 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
62 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
63 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
64 [ -n "$PACKAGES" ] || PACKAGES='yes'
65 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
66 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
67 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
68 [ -n "$RELEASE" ] || RELEASE='bookworm'
69 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
70 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
71 [ -n "$SECURE" ] || SECURE='yes'
72 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
73 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
74 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
75 [ -n "$VMSIZE" ] || VMSIZE="2G"
76 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
77
78 # inside the chroot system locales might not be available, so use minimum:
79 export LANG=C
80 export LC_ALL=C
81 export LANGUAGE=C
82
83 # make sure interactive mode is only executed when
84 # using an empty configuration file or option --interactive
85 INTERACTIVE=''
86 # }}}
87
88 # help text {{{
89 usage() {
90   echo "$PN - wrapper around debootstrap for installing Debian
91
92 Usage: $PN [options]
93
94 Bootstrap options:
95
96   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
97   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
98                          instead of fetching packages from a mirror.
99   -r, --release <name>   Release of new Debian system (default: bullseye).
100   -t, --target <target>  Target partition (/dev/...) or directory where the
101                          system should be installed to.
102   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
103                          has no effect if -t is given and represents a directory.
104       --debopt <params>  Extra parameters passed to the debootstrap command.
105       --interactive      Use interactive mode (frontend).
106       --nodebootstrap    Skip debootstrap, only do configuration to the target.
107       --grub <device>    Target for grub installation. Usage example: /dev/sda
108       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
109       --arch <arch>      Set target architecture, use for installing i386 on amd64.
110       --filesystem <fs>  Filesystem that should be used when target is a partition
111                          or Virtual Machine (see --vmfile).
112       --force            Do not prompt for user acknowledgement.
113
114 Options for Virtual Machine deployment:
115
116       --vm               Set up a Virtual Machine on an existing block device
117                          instead of plainly installing to a partition or
118                          directory. Needs to be combined with --target.
119                          Example: --vm --target /dev/mapper/your-vm-disk
120       --vmfile           Like --vm, but install into a regular file (created by
121                          'qemu-img create -f raw ...') instead.
122                          Example: --vmfile --target /mnt/sda1/qemu.img
123       --vmsize <size>    Use specified size for size of VM file (default: 2G).
124                          Syntax as supported by qemu-img, like: --vmsize 3G
125       --vmefi            Create an EFI boot partition for the VM.
126
127 Configuration options:
128
129   -c, --config <file>      Use specified configuration file, defaults to
130                              /etc/debootstrap/config
131   -d, --confdir <path>     Place of config files for debootstrap, defaults
132                              to /etc/debootstrap
133       --packages <file>    Install packages defined in specified list file
134                              instead of using /etc/debootstrap/packages.
135       --nopackages         Skip installation of packages defined in
136                              /etc/debootstrap/packages
137       --nokernel           Skip installation of default kernel images.
138       --nointerfaces       Do not copy /etc/network/interfaces from host system
139                            to target system.
140                            (This option is automatically enabled when using --vmfile.)
141       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
142                            DHCP for eth0) instead of taking over config from host system.
143       --debconf <file>     Pre-seed packages using specified pre-seed db file.
144       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
145       --backportrepos      Enable Debian's backports repository (backports.debian.org).
146       --keep_src_list      Do not overwrite user provided apt sources.list.
147       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
148       --non-free           Enable non-free / non-free-firmware in COMPONENTS (defaults to 'main' only).
149       --hostname <name>    Hostname of Debian system.
150       --nopassword         Do not prompt for the root password.
151       --password <pwd>     Use specified password as password for user root.
152       --sshcopyauth        Use ${HOME}/.ssh/authorized_keys to authorise root login on the target system.
153       --sshcopyid          Use locally available public keys to authorise root login on the target system.
154       --bootappend <line>  Add specified appendline to kernel whilst booting.
155       --chroot-scripts <d> Execute chroot scripts from specified directory.
156       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
157       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
158       --remove-configs     Delete grml-debootstrap configuration files from installed system.
159
160 Other options:
161
162   -v, --verbose            Increase verbosity.
163       --debug              Execute in very verbose way.
164   -h, --help               Print this usage information and exit.
165   -V, --version            Show summary of options and exit.
166
167 Usage examples can be found in the grml-debootstrap manpage.
168 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
169 "
170 }
171
172 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
173    usage
174    echo 'Please notice that this script requires root permissions!'
175    exit 0
176 fi
177 # }}}
178
179 # early helper functions {{{
180 # skip colors when running within a dumb terminal
181 if [ "${TERM}" = "dumb" ] ; then
182   GOOD=
183   BAD=
184   WARN=
185   NORMAL=
186 else
187   GOOD='\e[32;01m'
188   BAD='\e[31;01m'
189   WARN='\e[33;01m'
190   NORMAL='\e[0m'
191 fi
192
193 einfo() {
194   einfon "$1\\n"
195   return 0
196 }
197
198 einfon() {
199   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
200   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
201   LAST_E_CMD=einfon
202   return 0
203 }
204
205 ewarn() {
206   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
207   return 0
208 }
209
210 eerror() {
211   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
212   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
213   LAST_E_CMD=eerror
214   return 0
215 }
216
217 eend() {
218   local retval="${1:-0}"
219   shift
220   if [ "$retval" -gt 0 ]; then
221     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
222   fi
223   return "$retval"
224 }
225
226 check4root(){
227   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
228     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
229   fi
230 }
231
232 check4progs(){
233   local RC=''
234   for arg in "$@" ; do
235     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
236   done
237   if [ -n "$RC" ] ; then
238      echo "$RC not installed"
239      return 1
240   fi
241 }
242 # }}}
243
244 # helper functions {{{
245 cleanup() {
246   if [ -n "$CHROOT_VARIABLES" ] ; then
247     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" || eend $?
248   fi
249
250   if [ -n "$STAGES" ] ; then
251     einfo "Removing ${STAGES}" ; rmdir "$STAGES" || eend $?
252   fi
253
254   try_umount 3 "${MNTPOINT}"/boot/efi
255
256   # Remove temporary mountpoint again
257   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
258     if [ -d "$MNTPOINT" ] ; then
259       rmdir "$MNTPOINT" || true
260     fi
261   fi
262
263   # make sure $TARGET is not mounted when exiting grml-debootstrap
264   if [ -n "$MNTPOINT" ] ; then
265     if grep -q "$MNTPOINT" /proc/mounts ; then
266       # make sure nothing is left inside chroot so we can unmount it
267       for service in ssh mdadm ; do
268         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
269           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
270         fi
271       done
272
273       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1 || true
274
275       # ugly, but make sure we really don't leave anything (/proc /proc and
276       # /dev /dev are intended, trying to work around timing issues, see #657023)
277       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
278         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1 || true
279         umount "$MNTPOINT"/$ARG >/dev/null 2>&1 || true
280       done
281
282       if [ -n "$ISODIR" ] ; then
283         try_umount 3 "$MNTPOINT/$ISODIR" >/dev/null 2>&1 || true
284       fi
285
286       if [ -n "$DIRECTORY" ] ; then
287         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
288       else
289         einfo "Unmounting $MNTPOINT"
290         try_umount 3 "$MNTPOINT"
291       fi
292
293       if [ -n "$STAGES" ] ; then
294         echo -n "Removing stages directory ${STAGES}: "
295         rm -rf "$STAGES" && echo 'done'
296       fi
297
298       # remove directory only if we used the default with process id inside the name
299       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
300         if [ -d "$MNTPOINT" ] ; then
301           einfo "Removing directory ${MNTPOINT}"
302           rmdir "$MNTPOINT" || eend $?
303         fi
304       fi
305     fi
306   fi
307
308   if [ -n "${ORIG_TARGET}" ] ; then
309     einfo "Removing loopback mount of file ${ORIG_TARGET}."
310     kpartx -d "${ORIG_TARGET}" || eend $?
311     # Workaround for a bug in kpartx which doesn't clean up properly,
312     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
313     if dmsetup ls | grep -q "^${LOOP_PART} "; then
314       kpartx -d "/dev/${LOOP_DISK}" >/dev/null || eend $?
315     fi
316   fi
317 }
318
319 # we want to exit smoothly and clean:
320 bailout(){
321   eend "$1" || true
322
323   cleanup
324
325   [ -n "$1" ] && EXIT="$1" || EXIT="1"
326   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
327
328   exit "$EXIT"
329 }
330 trap bailout HUP INT QUIT TERM
331
332 # we want to execute all the functions only once, simple check for it:
333 stage() {
334   if [ -n "$2" ] ; then
335      echo "$2" > "${STAGES}/${1}"
336      return 0
337   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
338      ewarn "Notice: stage $1 has been executed already, skipping execution therefore."
339      ewarn "  To reexecute it clean up the according directory inside $STAGES"
340      return 1
341   fi
342 }
343 # }}}
344
345 # source main configuration file {{{
346 if [ -r /etc/debootstrap/config ] ; then
347   bash -n /etc/debootstrap/config
348   # shellcheck disable=SC1091
349   . /etc/debootstrap/config
350 fi
351 # }}}
352
353 # cmdline handling {{{
354 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
355
356 if ! _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
357   $CMDLINE_OPTS -- "$@"); then
358   eerror "Try 'grml-debootstrap --help' for more information."
359   bailout 1
360 fi
361 eval set -- "$_opt_temp"
362
363 while :; do
364   case "$1" in
365
366   # == Bootstrap options
367   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
368     shift; _opt_mirror="$1"
369     ;;
370   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
371     shift; _opt_iso="$1"
372     ;;
373   --release|-r)        # Release of new Debian system
374     shift; _opt_release="$1"
375     ;;
376   --target|-t)         # Target partition (/dev/...) or directory
377     shift; _opt_target="$1"
378     ;;
379   --vm)                # Virtual machine image (no file)
380     _opt_vm="T"
381     ;;
382   --vmfile)            # Virtual machine file
383     _opt_vmfile="T"
384     ;;
385   --vmsize)            # size of Virtual machine file
386     shift; _opt_vmsize="$1"
387     ;;
388   --vmefi)            # Create an EFI boot partition for the VM
389     _opt_vmefi="T"
390     ;;
391   --mntpoint|-p)       # Mountpoint used for mounting the target system
392     shift; _opt_mntpoint="$1"
393     ;;
394   --debopt)            # Extra parameters passed to the debootstrap command
395     shift; _opt_debopt="$1"
396     ;;
397   --filesystem)        # Filesystem that should be used
398     shift; _opt_filesystem="$1" ; FILESYSTEM="${_opt_filesystem}"
399     ;;
400   --interactive)       # Use interactive mode (frontend)
401     _opt_interactive=T
402     ;;
403   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
404     _opt_nodebootstrap=T
405     ;;
406   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
407     _opt_nopackages=T
408     ;;
409   --arch)              # Target architecutre
410     shift; _opt_arch="$1"
411     ;;
412   # just for backwards compatibility
413   --insecure)
414     _opt_insecure=T
415     ;;
416   #
417
418   # == Configuration options
419   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
420     shift; _opt_config="$1"
421     ;;
422   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
423     shift; _opt_confdir="$1"
424     ;;
425   --packages)          # Install packages defined in specified file
426     shift; _opt_packages="$1"
427     _opt_packages_set=T
428     ;;
429   --debconf)           # Pre-seed packages using specified file
430     shift; _opt_debconf="$1"
431     _opt_debconf_set=T
432     ;;
433   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
434     shift; _opt_pre_scripts="$1"
435     _opt_pre_scripts_set=T
436     ;;
437   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
438     shift; _opt_scripts="$1"
439     _opt_scripts_set=T
440     ;;
441   --post-scripts)       # Execute scripts from specified directory
442     shift; _opt_post_scripts="$1"
443     _opt_post_scripts_set=T
444     ;;
445   --chroot-scripts)   # Execute chroot scripts from specified directory
446     shift; _opt_chroot_scripts="$1"
447     _opt_chroot_scripts_set=T
448     ;;
449   --keep_src_list)     # Do not overwrite user provided apt sources.list
450     _opt_keep_src_list=T
451     ;;
452   --hostname)          # Hostname of Debian system
453     shift; _opt_hostname="$1"
454     ;;
455   --password)          # Use specified password as password for user root
456     shift; _opt_password="$1"
457     ;;
458   --defaultinterfaces) # Install default /etc/network/interfaces
459     _opt_defaultinterfaces=T
460     ;;
461   --nointerfaces)      # Skip installation of /etc/network/interfaces
462     _opt_nointerfaces=T
463     ;;
464   --nokernel)          # Skip installation of default kernel images
465     _opt_nokernel=T
466     ;;
467   --nopassword)        # Skip password dialog
468     _opt_nopassword=T
469     ;;
470   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
471     _opt_sshcopyid=T
472     ;;
473   --sshcopyauth)       # Use .ssh/authorized_keys to authorise root login on the target system
474     _opt_sshcopyauth=T
475     ;;
476   --grmlrepos)         # Enable Grml repository
477     _opt_grmlrepos=T
478     ;;
479   --backportrepos)     # Enable Debian backports repository
480     _opt_backportrepos=T
481     ;;
482   --bootappend)        # Add specified appendline to kernel whilst booting
483     shift; _opt_bootappend="$1"
484     ;;
485   --grub)              # Target for grub installation. Use grub syntax for specifying
486     shift; _opt_grub="$1"
487     ;;
488   --efi)               # Target for EFI boot installation
489     shift; _opt_efi="$1"
490     ;;
491   --contrib)           # Add 'contrib' to list of components
492     _opt_contrib=T
493     ;;
494   --non-free)          # Add 'non-free' to list of components
495     _opt_non_free=T
496     ;;
497   --remove-configs)    # Drop config files from installed system
498     _opt_remove_configs=T
499     ;;
500
501   # == Other options
502   --verbose|-v)        # Increase verbosity
503     if [ "$_opt_verbose" ]; then
504       _opt_verbose=$( _opt_verbose + 1 )
505     else
506       _opt_verbose=1
507     fi
508     ;;
509   --debug)             # Execute in debug mode
510     _opt_debug=T
511     ;;
512   --help|-h)           # Print usage information and exit
513     _opt_help=T
514     ;;
515   --version|-V)        # Show version information and exit
516     _opt_version=T
517     ;;
518   --force)             # Do not prompt for user input
519     _opt_force=T
520     ;;
521   --)
522     shift; break
523     ;;
524   *)
525     eerror "Internal getopt error!"; eend 1 ; exit 1
526     ;;
527   esac
528   shift
529 done
530
531 # == business-logic of command line parameter-processing
532
533 # source configuration file in <confdir> if supplied. {{{
534 [ "$_opt_confdir" ] && {
535   CONFFILES=$_opt_confdir
536   einfo "Using config files under $CONFFILES/."
537   if ! [ -r "$CONFFILES/config" ] ; then
538     eerror "Error: config file $CONFFILES/config not found."; bailout 1
539   fi
540   # shellcheck disable=SC1091 source=config
541   if ! . "$CONFFILES/config" ; then
542     eerror "Error reading config file $CONFFILES/config" ; bailout 1
543   fi
544   # restore the command line parameter value
545   CONFFILES=$_opt_confdir
546 }
547 # }}}
548
549 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
550 [ "$_opt_iso" ]                 && ISO=$_opt_iso
551 [ "$_opt_release" ]             && RELEASE=$_opt_release
552 [ "$_opt_target" ]              && TARGET=$_opt_target
553 [ "$_opt_vm" ]                  && VIRTUAL=1
554 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
555 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
556 [ "$_opt_vmefi" ]               && VMEFI=1
557 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
558 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
559 [ "$_opt_interactive" ]         && INTERACTIVE=1
560 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
561 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
562 [ "$_opt_packages_set" ]        && PACKAGES='yes'
563 [ "$_opt_nopackages" ]          && PACKAGES=''
564 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
565 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
566 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
567 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
568 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
569 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
570 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
571 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
572 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
573 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
574 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
575 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
576 [ "$_opt_nokernel" ]            && NOKERNEL="true"
577 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
578 [ "$_opt_sshcopyauth" ]         && SSHCOPYAUTH="true"
579 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
580 [ "$_opt_grub" ]                && GRUB=$_opt_grub
581 [ "$_opt_efi" ]                 && EFI=$_opt_efi
582 [ "$_opt_arch" ]                && ARCH=$_opt_arch
583 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
584 [ "$_opt_force" ]               && FORCE=$_opt_force
585 [ "$_opt_verbose" ]             && VERBOSE="-v"
586 [ "$_opt_debug" ]               && DEBUG="true"
587 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
588
589 # make sure main is always included
590 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
591 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
592
593 case "${RELEASE}" in
594   jessie|stretch|buster|bullseye)
595     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free"
596     ;;
597   *)
598     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free-firmware non-free"
599     ;;
600 esac
601
602 # command line option checks
603 if [ "$_opt_scripts_set" ] ; then
604   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
605   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
606 fi
607
608 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
609   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
610   eerror "The --grub option is unneeded as GRUB will be installed automatically (unless GRUB_INSTALL='no')."
611   bailout 1
612 fi
613
614 if [ "${_opt_sshcopyid}" ] && [ "${_opt_sshcopyauth}" ] ; then
615   eerror "The --sshcopyid option is incompatible with --sshcopyauth, please drop either of them from your command line."
616   bailout 1
617 fi
618
619 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
620   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
621   eerror "Either drop the --iso ... option or use plain debootstrap instead."
622   bailout 1
623 fi
624
625 if [ "$DEBUG" = "true" ] ; then
626   set -x
627 fi
628
629 [ "$_opt_help" ] && {
630   usage
631   exit 0
632 }
633
634 [ "$_opt_version" ] && {
635   einfo "$PN - version $VERSION"
636   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
637   exit 0
638 }
639 # }}}
640
641 # check for root permissions {{{
642 if ! check4root ; then
643    echo "For usage instructions please execute '$PN --help'."
644    bailout 1
645 fi
646 # }}}
647
648 # make sure we have what we need {{{
649 check4progs "${DEBOOTSTRAP}" || bailout 1
650
651 if [ -n "$VIRTUAL" ] ; then
652   check4progs kpartx parted qemu-img || bailout 1
653 fi
654 # }}}
655
656 # source specified configuration file {{{
657 if [ -n "$CONFIGFILE" ] ; then
658   einfo "Reading specified config file $CONFIGFILE."
659   bash -n "$CONFIGFILE"
660   # shellcheck disable=SC1091 source=config
661   if ! . "$CONFIGFILE" ; then
662     eerror "Error reading config file $CONFIGFILE" ; bailout 1
663   fi
664 fi
665 # }}}
666
667 # backwards compatibility checks {{{
668 if [ -n "$GROOT" ] ; then
669    eerror "Error: you seem to have \$GROOT configured."
670    eerror "This variable is no longer supported, please visit the"
671    eerror "grml-debootstrap documentation for details."
672    bailout 1
673 fi
674
675 if echo "$GRUB" | grep -q '^hd' ; then
676    eerror "Error: this syntax for the grub configuration variable is no longer supported."
677    eerror "Please do not use hd... any longer but /dev/sdX instead."
678    bailout 1
679 fi
680 # }}}
681
682 # welcome screen {{{
683 welcome_dialog()
684 {
685    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
686 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
687 }
688 # }}}
689
690 # ask for target {{{
691 prompt_for_target()
692 {
693   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
694                sed 's/*//' | \
695                grep -v 'Extended$' | \
696                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
697
698   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
699      dialog --title "$PN" --trim \
700      --msgbox "Sorry, no partitions found. Please configure your
701      harddisks (see /proc/partitions) using a tool like fdisk,
702      cfdisk, gpart, gparted,..." 0 0 || bailout 1
703   fi
704
705   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
706                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
707                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
708                      echo "$i" "$fs"
709                      unset fs
710                    done)
711
712   # shellcheck disable=SC2086
713   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
714          --menu "Please select the target partition:" 0 0 0 \
715          $PARTITION_LIST) || bailout 1
716 }
717 # }}}
718
719 # ask for bootmanager {{{
720 prompt_for_bootmanager()
721 {
722   ADDITIONAL_PARAMS=""
723
724   if echo "$TARGET" | grep -q "/dev/md" ; then
725      MBRPART="all disks of Software RAID $TARGET"
726   else
727      # figure out whole disk device
728      found=
729      for device in /dev/disk/by-id/*
730      do
731         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
732         found=1
733         break
734      done
735      # shellcheck disable=SC2001
736      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
737      if [ -e "$MBRDISK" ]; then
738         MBRDISK=$(readlink -f "$MBRDISK")
739      else
740         # fall back to old behaviour
741         # shellcheck disable=SC2001
742         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
743      fi
744
745      MBRPART="MBR of $MBRDISK"
746   fi
747
748   for device in cciss/c0d0 sda hda; do
749     if [ "/dev/$device" != "${MBRDISK}" ]; then
750       grep -q $device /proc/partitions && \
751       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
752     fi
753   done
754   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
755
756   OIFS="$IFS"; IFS=:
757
758   # shellcheck disable=SC2086
759   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
760           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
761             mbr       "install bootmanager into $MBRPART" \
762             nowhere   "do not install bootmanager at all" \
763           ${ADDITIONAL_PARAMS}) || bailout 3
764   IFS="$OIFS"
765
766   case "$GETMBR" in
767     mbr)
768       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
769       if echo "$TARGET" | grep -q "/dev/md" ; then
770         GRUB="$TARGET"
771       else
772         GRUB="$MBRDISK"
773       fi
774       ;;
775     hda)
776       GRUB="/dev/hda"
777       ;;
778     sda)
779       GRUB="/dev/sda"
780       ;;
781     nowhere)
782       GRUB=''
783       ;;
784   esac
785 }
786 # }}}
787
788 # ask for Debian release {{{
789 prompt_for_release()
790 {
791   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='bullseye'
792   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
793             "Please enter the Debian release you would like to use for installation:" \
794             0 50 8 \
795             buster   Debian/10 \
796             bullseye Debian/11 \
797             bookworm Debian/12 \
798             sid      Debian/unstable)" \
799             || bailout
800 }
801 # }}}
802
803 # ask for hostname {{{
804 prompt_for_hostname()
805 {
806   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
807             "Please enter the hostname you would like to use for installation:" \
808             0 0 "$HOSTNAME")" || bailout
809 }
810 # }}}
811
812 # ask for password {{{
813 prompt_for_password()
814 {
815   if [ "$_opt_nopassword" ] ; then
816     einfo "Skip asking for root password as requested."
817     return 0
818   fi
819
820   ROOTPW1='PW1'
821   ROOTPW2='PW2'
822   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
823     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
824     "Please enter the password for the root account:" 10 60) || bailout
825
826     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
827     "Please enter the password for the root account again for \
828     confirmation:" 10 60) || bailout
829
830     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
831       dialog --stdout --title "${PN}" --ok-label \
832         "Retry" --msgbox "Passwords do not match!" 10 60
833     fi
834   done
835   ROOTPASSWORD="$ROOTPW1"
836 }
837 # }}}
838
839 # ask for Debian mirror {{{
840 prompt_for_mirror()
841 {
842   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
843
844   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
845           --menu "Where do you want to install from?" 0 0 0 \
846             net   "install via network (downloading from mirror)" \
847             local "install from local directory/mirror"
848           )
849
850   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
851      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
852      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
853                "Please enter Debian mirror you would like to use for installing packages." \
854                0 0 $MIRROR)" || bailout
855
856   else # CHOOSE_MIRROR == local
857      [ -n "$ISO" ] || ISO='/mnt/mirror'
858      ISO="$(dialog --stdout --title "${PN}" --inputbox \
859                "Please enter directory name you would like to use for installing packages." \
860                0 0 $ISO)" || bailout
861   fi
862 }
863 # }}}
864
865 # software raid setup {{{
866 config_swraid_setup()
867 {
868 TMPFILE=$(mktemp)
869
870 # Currently we support only raid1:
871 RAIDLEVEL='raid1'
872
873 MD_LIST=$(for i in $(seq 0 9) ; do
874             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
875             echo "/dev/md$i /dev/md$i"
876           done)
877
878 # shellcheck disable=SC2086
879 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
880 --menu "Which device do you want to use for ${RAIDLEVEL}?
881
882 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
883 $MD_LIST) || bailout 20
884
885 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
886              sed 's/*//' | \
887              grep -v 'Extended$' | \
888              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
889 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
890 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
891                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
892                  done)
893
894 # shellcheck disable=SC2086
895 dialog --title "$PN" --separate-output \
896        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
897        $PARTITION_LIST 2>"$TMPFILE" || bailout
898
899 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
900
901 NUM_PARTITIONS=0
902 while IFS= read -r i; do
903   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
904 done < "$TMPFILE"
905
906 ERRORFILE=$(mktemp)
907
908 local RC=0
909 # shellcheck disable=SC2086
910 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
911       --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE || RC=$?
912
913 if [ "$RC" = 0 ] ; then
914    dialog --title "$PN" --msgbox \
915    "Creating $TARGET was successful." 0 0
916    rm -f "$TMPFILE" "$ERRORFILE"
917 else
918    dialog --title "$PN" --msgbox \
919    "There was an error setting up $TARGET:
920
921 $(cat "$ERRORFILE")
922
923 Exiting." 0 0
924    rm -f "$TMPFILE" "$ERRORFILE"
925    bailout 1
926 fi
927
928 }
929
930 prompt_for_swraid()
931 {
932 if dialog --stdout --title "$PN" \
933           --defaultno --yesno "Do you want to configure Software RAID?
934
935 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
936   config_swraid_setup
937 fi
938 }
939 # }}}
940
941 # user should recheck his configuration {{{
942 # support full automatic installation:
943 checkforrun() {
944    dialog --timeout 10 --title "$PN" \
945           --yesno "Do you want to stop at this stage?
946
947 Notice: you are running ${PN} in non-interactive mode.
948 ${PN} will install Debian ${RELEASE} on ${TARGET}.
949 Last chance to quit. Timeout of 10 seconds running....
950
951 Do you want to stop now?" 0 0 2>/dev/null
952 }
953 # }}}
954
955 # format efi partition {{{
956 format_efi_partition() {
957   if [ -z "$EFI" ] ; then
958     return 0
959   fi
960
961   if ! [ -b "$EFI" ] ; then
962     eerror "Specified efi argument [$EFI] not a valid block device."
963     bailout 1
964   fi
965
966   if fsck.vfat -bn "$EFI" >/dev/null; then
967     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying."
968   else
969     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
970     if ! mkfs.fat -F32 -n "EFI" "$EFI" ; then
971       eerror "Error while creating filesystem on ${EFI}."
972       bailout 1
973     fi
974   fi
975 }
976 # }}}
977
978 # check for EFI support or try to enable it {{{
979 efi_support() {
980   local efivars_loaded=false
981   # this is for kernels versions before v3.10, which didn't provide efivarfs yet
982   if modprobe efivars &>/dev/null ; then
983     efivars_loaded=true
984   fi
985   # kernel versions v3.10 and newer usually provide efivarfs
986   if modprobe efivarfs &>/dev/null ; then
987     efivars_loaded=true
988   fi
989
990   if [ -d /sys/firmware/efi ] ; then
991     einfo "EFI support detected."
992     return 0
993   fi
994
995   if ! [ -d /sys/firmware/efi ] && [ "${efivars_loaded:-}" = "true" ] ; then
996     einfo "EFI support detected, but system seems to be running in BIOS mode."
997   fi
998
999   return 1
1000 }
1001 # }}}
1002
1003 # make sure the user is aware of the used configuration {{{
1004 checkconfiguration()
1005 {
1006
1007 if [ -z "$VIRTUAL" ] ; then
1008   if efi_support ; then
1009     if [ -z "$_opt_efi" ] ; then
1010       ewarn "EFI support detected but no --efi option given, please consider enabling it."
1011     fi
1012   else
1013     if [ -n "$_opt_efi" ] ; then
1014       eerror "EFI option used but no EFI support detected."
1015       bailout 1
1016     fi
1017   fi
1018 fi
1019
1020 if [ -n "$AUTOINSTALL" ] ; then
1021    if checkforrun ; then
1022       eerror "Exiting as requested"
1023       bailout 1
1024    fi
1025 elif [ -n "$INTERACTIVE" ] ; then
1026
1027    INFOTEXT="Please recheck configuration before execution:
1028    "
1029    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1030    Target:          $TARGET"
1031    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1032    Install grub:    $GRUB"
1033    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1034    Install efi:     $EFI"
1035    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1036    Using release:   $RELEASE"
1037    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1038    Using hostname:  $HOSTNAME"
1039    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1040    Using mirror:    $MIRROR"
1041    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1042    Using ISO:       $ISO"
1043    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1044    Using arch:      $ARCH"
1045    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1046    Config files:    $CONFFILES"
1047
1048    INFOTEXT="$INFOTEXT
1049
1050 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1051
1052    dialog --title "$PN" --no-collapse \
1053           --yesno "$INFOTEXT" 0 0 || bailout 0
1054
1055 else # if not running automatic installation display configuration and prompt for execution:
1056    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1057    echo
1058    echo "   Target:          $TARGET"
1059
1060    # do not display if MNTPOINT is the default one
1061    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1062
1063    if [ -n "$VIRTUAL" ] && [ "$GRUB_INSTALL" = 'yes' ] ; then
1064       echo "   Install grub:    yes"
1065       [ -n "$VMEFI" ]   && echo "   Install efi:     yes"   || echo "   Install efi:     no"
1066    else
1067      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1068      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1069    fi
1070
1071    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1072    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1073    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1074    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1075    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1076    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1077    if [ -n "$VIRTUAL" ] ; then
1078       echo "   Deploying as Virtual Machine."
1079       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1080          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1081       fi
1082    fi
1083
1084    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1085       echo
1086       echo "   You do not have a TTY allocated, your password will be shown in"
1087       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1088    fi
1089
1090    echo
1091    echo "   Important! Continuing will delete all data from ${TARGET}!"
1092
1093    if [ -n "$FORCE" ] ; then
1094      einfo "Skip user acknowledgement as requested via --force option."
1095    else
1096      echo
1097      einfon "Is this ok for you? [y/N] "
1098      read -r a
1099      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1100         eerror "Exiting as requested."
1101         bailout 1
1102      fi
1103    fi
1104 fi
1105 }
1106 # }}}
1107
1108 # interactive mode {{{
1109 interactive_mode()
1110 {
1111   check4progs dialog || bailout 1
1112
1113   welcome_dialog
1114
1115   prompt_for_release
1116
1117   prompt_for_swraid
1118
1119   prompt_for_target
1120
1121   prompt_for_bootmanager
1122
1123   prompt_for_hostname
1124
1125   prompt_for_password
1126
1127   prompt_for_mirror
1128 }
1129
1130 # run interactive mode if we didn't get the according configuration yet
1131 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1132    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1133    INTERACTIVE=1
1134    interactive_mode
1135 fi
1136 # }}}
1137
1138 # architecture setup {{{
1139 if [ -n "$ARCH" ] ; then
1140    ARCHCMD="--arch $ARCH"
1141    ARCHINFO=" (${ARCH})"
1142 else
1143    ARCH="$(dpkg --print-architecture)"
1144    ARCHCMD="--arch $ARCH"
1145    ARCHINFO=" (${ARCH})"
1146 fi
1147
1148 if [ -z "${ARCH:-}" ] ; then
1149   eerror 'Architecture neither set (environment variable ARCH), nor could be automatically identified (using dpkg).'
1150   eerror 'Consider setting the --arch ... option.'
1151   bailout 1
1152 fi
1153 # }}}
1154
1155 # It is not possible to build amd64 on i686. {{{
1156 CURRENT_ARCH="$(uname -m)"
1157 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1158    if [ "$ARCH" = "amd64" ] ; then
1159       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead."
1160       bailout 1
1161    fi
1162 fi
1163 # }}}
1164
1165 # Support for generic release codenames is unavailable. {{{
1166 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1167    eerror "Generic release codenames (stable, testing) are unsupported. \
1168 Please use specific codenames such as bullseye or bookworm."
1169    bailout 1
1170 fi
1171 # }}}
1172
1173 checkconfiguration
1174
1175 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1176 if [ -n "$TARGET" ] ; then
1177    SHORT_TARGET="${TARGET##*/}"
1178 else
1179    eerror "Please adjust $CONFFILES/config or..."
1180    eerror "... use the interactive version for configuration before running ${0}"
1181    bailout 1
1182 fi
1183 # }}}
1184
1185 # stages setup {{{
1186 if [ -z "$STAGES" ] ; then
1187    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1188    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1189 fi
1190
1191 if [ -r "$STAGES"/grml-debootstrap ] ; then
1192    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1193       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1194       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}"
1195    fi
1196 fi
1197 # }}}
1198
1199 # partition handling {{{
1200 PARTITION=''
1201 DIRECTORY=''
1202
1203 set_target_directory(){
1204     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1205     DIRECTORY=1
1206     MNTPOINT="$TARGET"
1207     MKFS=''
1208     TUNE2FS=''
1209     FSCK=''
1210     # make sure we normalise the path to an absolute directory name so something like:
1211     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1212     # works
1213     TARGET="$(readlink -f "$TARGET")"
1214 }
1215
1216 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1217     PARTITION=1
1218 else
1219     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1220     if [[ $TARGET == "/dev/"* ]]; then
1221       eerror "Error: Will not create target directory $TARGET in /dev."
1222       eerror "  Please check the partition(s) of the blockdevice."
1223       bailout 1
1224     fi
1225     set_target_directory
1226 fi
1227 # }}}
1228
1229 # make sure we have the right syntax when using an iso image {{{
1230 if [ -n "$ISO" ] ; then
1231    case $ISO in
1232       file*) # do nothing
1233       ;;
1234       *)
1235       ISO=file:$ISO
1236       ;;
1237    esac
1238 fi
1239 ISODIR=${ISO##file:}
1240 ISODIR=${ISODIR%%/}
1241 # }}}
1242
1243 # Debian ISOs do not contain signed Release files {{{
1244 if [ -n "$ISO" ] ; then
1245     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1246 fi
1247 # }}}
1248
1249 # create filesystem {{{
1250 mkfs() {
1251   if [ -n "$DIRECTORY" ] ; then
1252      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1253      return 0
1254   fi
1255
1256   if grep -q "$TARGET" /proc/mounts ; then
1257     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)"
1258     bailout 1
1259   fi
1260
1261   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1262   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1263   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1264     case "$MKFS" in
1265       mkfs.ext*)
1266         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1267         MKFS_OPTS="$MKFS_OPTS -F"
1268         ;;
1269     esac
1270   fi
1271
1272   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1273   # by default, which requires a recent version of tune2fs on the target system then,
1274   # so disable this feature for older Debian releases where it's known to be unsupported
1275   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1276     case "$RELEASE" in
1277       jessie)
1278         # assume a more recent version if we can't identify the version via dpkg-query
1279         local e2fsprogs_version
1280         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1281         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1282           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1283           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1284         fi
1285         ;;
1286     esac
1287   fi
1288
1289   # starting with e2fsprogs v1.47.0 mkfs.ext4 enables the metadata_csum_seed feature
1290   # by default, which requires Linux kernel >=4.4, e2fsprogs >=1.43, according GRUB etc.
1291   # Disable this feature for Debian releases older than bookworm
1292   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1293     case "$RELEASE" in
1294       jessie|stretch|buster|bullseye)
1295         local e2fsprogs_version
1296         # assume a more recent version if we can't identify the version via dpkg-query
1297         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.47)"
1298         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43' ; then
1299           einfo "Disabling metadata_csum_seed feature for $MKFS as $RELEASE doesn't support it."
1300           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum_seed"
1301         fi
1302         ;;
1303     esac
1304   fi
1305
1306   if [ -n "$MKFS" ] ; then
1307
1308     if [ -n "${ARM_EFI_TARGET}" ] ; then
1309       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
1310       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
1311       MKFS_OPTS="$MKFS_OPTS -L LINUX"
1312     fi
1313
1314     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1315     # shellcheck disable=SC2086
1316     "$MKFS" $MKFS_OPTS "$TARGET"
1317
1318     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1319       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1320         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1321         bailout 1
1322       else
1323         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1324         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
1325       fi
1326     fi
1327
1328     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
1329       einfo "Creating FAT filesystem on $EFI_TARGET"
1330       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
1331     fi
1332
1333     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1334     # will fail to detect the uuid in the chroot
1335     if [ -n "$VIRTUAL" ] ; then
1336       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1337     elif echo "$TARGET" | grep -q "/dev/md" ; then
1338       blockdev --rereadpt "${TARGET}"
1339     else
1340       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1341       local main_device="${TARGET%%[0-9]*}"
1342       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1343       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1344         blockdev --rereadpt "$main_device"
1345       else
1346         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1347       fi
1348     fi
1349     # give the system 2 seconds, otherwise we might run into
1350     # race conditions :-/
1351     sleep 2
1352
1353   fi
1354 }
1355 # }}}
1356
1357 # retrieve ID_FS_UUID {{{
1358 identify_target_uuid() {
1359   local device="$1"
1360
1361   if ! [ -b "$device" ] ; then
1362     return 1
1363   fi
1364
1365   eval "$(blkid -o udev "$1" 2>/dev/null)"
1366
1367   if [ -n "$ID_FS_UUID" ] ; then
1368     echo "$ID_FS_UUID"
1369   else
1370     return 1
1371   fi
1372 }
1373 # }}}
1374
1375 # identify TARGET_UUID {{{
1376 mountpoint_to_blockdevice() {
1377   TARGET_UUID=''
1378
1379   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1380   if [ -n "$TARGET_UUID" ] ; then
1381     einfo "Identified UUID $TARGET_UUID for $TARGET"
1382     return 0
1383   fi
1384
1385   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1386   for file in /sys/block/*/*/dev ; do
1387     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1388       local dev
1389       dev="${file%/dev}"
1390       dev="/dev/${dev##*/}"
1391       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1392
1393       if [ -n "$TARGET_UUID" ] ; then
1394         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1395         return 0
1396       fi
1397     fi
1398   done
1399 }
1400 # }}}
1401
1402 # modify filesystem settings {{{
1403 tunefs() {
1404   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1405      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1406      $TUNE2FS "$TARGET" </dev/null
1407   fi
1408 }
1409 # }}}
1410
1411 # mount the new partition or if it's a directory do nothing at all {{{
1412 mount_target() {
1413   if [ -n "$DIRECTORY" ] ; then
1414      einfo "Running grml-debootstrap on a directory, nothing to mount."
1415   else
1416      if grep -q "$TARGET" /proc/mounts ; then
1417         ewarn "$TARGET already mounted, continuing anyway."
1418      else
1419        if ! [ -d "${MNTPOINT}" ] ; then
1420           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1421        fi
1422        einfo "Mounting $TARGET to $MNTPOINT"
1423        mkdir -p "$MNTPOINT"
1424        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1425      fi
1426   fi
1427   if [ -n "$ISODIR" ] ; then
1428      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1429      mkdir -p "$MNTPOINT/$ISODIR"
1430      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1431   fi
1432 }
1433 # }}}
1434
1435 # prepare VM image for usage with debootstrap {{{
1436 prepare_vm() {
1437   if [ -z "$VIRTUAL" ] ; then
1438      return 0 # be quiet by intention
1439   fi
1440
1441   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1442      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1443      bailout 1
1444   fi
1445   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1446      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1447      bailout 1
1448   fi
1449
1450   # make sure loop module is present and a usable loop device exists
1451   modprobe loop || true
1452   if ! losetup -f >/dev/null 2>&1; then
1453     eerror "Error finding usable loop device"
1454     bailout 1
1455   fi
1456
1457   # if dm-mod isn't available then kpartx will fail with
1458   # "Is device-mapper driver missing from kernel? [...]"
1459   modprobe dm-mod || true
1460   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1461     eerror "Device-mapper support missing in kernel."
1462     bailout 1
1463   fi
1464
1465   ORIG_TARGET="$TARGET" # store for later reuse
1466
1467   if [ -n "$VMFILE" ]; then
1468     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1469   fi
1470   if [ -n "$VMEFI" ]; then
1471     parted -s "${TARGET}" 'mklabel gpt'
1472     parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 101MiB'
1473     parted -s "${TARGET}" 'set 1 boot on'
1474     parted -s "${TARGET}" 'mkpart bios_grub 101MiB 102MiB'
1475     parted -s "${TARGET}" 'set 2 bios_grub on'
1476     parted -s "${TARGET}" 'mkpart primary ext4 102MiB 100%'
1477
1478   else
1479     # arm64 support largely only exists for GPT
1480     if [ "$ARCH" = 'arm64' ]; then
1481       einfo "Setting up GPT partitions for arm64"
1482       parted -s "${TARGET}" 'mklabel gpt'
1483       parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 10MiB'
1484       parted -s "${TARGET}" 'set 1 boot on'
1485       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
1486     else
1487       parted -s "${TARGET}" 'mklabel msdos'
1488       if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1489         einfo "Adjusting disk signature to a fixed (non-random) value"
1490         MBRTMPFILE=$(mktemp)
1491         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1492         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1493         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1494       fi
1495       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
1496       parted -s "${TARGET}" 'set 1 boot on'
1497     fi
1498   fi
1499
1500   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3' - will be multi-line for arm64
1501   if [ -z "${DEVINFO}" ] ; then
1502     eerror "Error setting up loopback device."
1503     bailout 1
1504   fi
1505
1506   # if we're building for arm64, we operate on the first line of $DEVINFO which is the EFI partition
1507   if [ "$ARCH" = 'arm64' ]; then
1508     LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1509     LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1510     LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1511     export ARM_EFI_TARGET="/dev/mapper/$LOOP_PART"
1512     DEVINFO=${DEVINFO##*$'\n'} # now set $DEVINFO to the last line which is the OS partition
1513   fi
1514
1515   # hopefully this always works as expected
1516   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1517   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1518   if [ -n "$VMEFI" ]; then
1519     export EFI_TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1520     LOOP_PART="${LOOP_PART%p1}p3"
1521   fi
1522   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1523   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1524
1525   if [ -z "$TARGET" ] ; then
1526      eerror "Error: target could not be set to according /dev/mapper/* device."
1527      bailout 1
1528   fi
1529 }
1530 # }}}
1531
1532 # make VM image bootable {{{
1533 grub_install() {
1534   if [ -z "${VIRTUAL}" ] ; then
1535      return 0
1536   fi
1537   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1538     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1539     return 0
1540   fi
1541
1542   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1543     eerror "Error: Mounting ${TARGET} failed, can not continue."
1544     bailout 1
1545   fi
1546
1547   if [ -n "${ARM_EFI_TARGET}" ]; then
1548     mkdir -p "${MNTPOINT}"/boot/efi
1549     if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}"/boot/efi ; then
1550       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue."
1551       bailout 1
1552     fi
1553   fi
1554
1555   mount -t proc none "${MNTPOINT}"/proc
1556   mount -t sysfs none "${MNTPOINT}"/sys
1557   mount -t devtmpfs udev "${MNTPOINT}"/dev
1558   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1559
1560   if [ -n "$ARM_EFI_TARGET" ]; then
1561     einfo "Installing Grub as bootloader into EFI."
1562
1563     chroot "${MNTPOINT}" grub-install --target=arm64-efi --efi-directory=/boot/efi --bootloader-id=debian --recheck --no-nvram --removable
1564   # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1565   # chroot-script skips installation for unset ${GRUB}
1566   elif [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1567     einfo "Installing Grub as bootloader."
1568
1569     if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1570       echo "Notice: grub-pc package not present yet, installing it therefore."
1571       # shellcheck disable=SC2086
1572       DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-pc
1573     fi
1574
1575     mkdir -p "${MNTPOINT}/boot/grub"
1576     if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1577       eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader."
1578       bailout 1
1579     fi
1580     cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1581
1582     if [ -n "$VMEFI" ]; then
1583
1584       mkdir -p "${MNTPOINT}"/boot/efi
1585       mount -t vfat "${EFI_TARGET}" "${MNTPOINT}"/boot/efi
1586
1587       if ! chroot "${MNTPOINT}" dpkg --list shim-signed 2>/dev/null | grep -q '^ii' ; then
1588         echo "Notice: shim-signed package not present yet, installing it therefore."
1589         # shellcheck disable=SC2086
1590         DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS shim-signed
1591       fi
1592
1593       if [ "$(dpkg --print-architecture)" = "arm64" ]; then
1594         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-arm64-signed 2>/dev/null | grep -q '^ii' ; then
1595           echo "Notice: grub-efi-arm64-signed package not present yet, installing it therefore."
1596           # shellcheck disable=SC2086
1597           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-arm64-bin grub-efi-arm64-signed
1598         fi
1599         chroot "$MNTPOINT" grub-install --target=arm64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1600       elif [ "$(dpkg --print-architecture)" = "i386" ]; then
1601         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-ia32-signed 2>/dev/null | grep -q '^ii' ; then
1602           echo "Notice: grub-efi-ia32-signed package not present yet, installing it therefore."
1603           # shellcheck disable=SC2086
1604           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-ia32-bin grub-efi-ia32-signed
1605         fi
1606         chroot "$MNTPOINT" grub-install --target=i386-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1607         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1608       else
1609         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-amd64-signed 2>/dev/null | grep -q '^ii' ; then
1610           echo "Notice: grub-efi-amd64-signed package not present yet, installing it therefore."
1611           # shellcheck disable=SC2086
1612           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-amd64-bin grub-efi-amd64-signed
1613         fi
1614         chroot "$MNTPOINT" grub-install --target=x86_64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1615         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1616       fi
1617     else
1618       dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1619       case "${_opt_filesystem}" in
1620         f2fs)
1621           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos f2fs
1622           ;;
1623         xfs)
1624           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos xfs
1625           ;;
1626         # NOTE - we might need to distinguish between further filesystems
1627         *)
1628           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1629           ;;
1630       esac
1631
1632       dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1633       rm -f "${MNTPOINT}/tmp/core.img"
1634     fi
1635   fi
1636
1637   # workaround for Debian bug #918590 with lvm + udev:
1638   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1639   if [ -d /run/udev ] ; then
1640     einfo "Setting up bind-mount /run/udev"
1641     mkdir -p "${MNTPOINT}"/run/udev
1642     mount --bind /run/udev "${MNTPOINT}"/run/udev
1643   fi
1644
1645   if [ -n "${BOOT_APPEND}" ] ; then
1646     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
1647     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}/etc/default/grub"
1648   fi
1649
1650   einfo "Updating grub configuration file."
1651   chroot "${MNTPOINT}" update-grub
1652   chroot "${MNTPOINT}" sync
1653
1654   case "$RELEASE" in
1655     jessie)
1656       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1657       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1658       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1659       ;;
1660   esac
1661
1662   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1663     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1664     ewarn "Please note that your system might NOT be able to properly boot."
1665   elif [ -z "$ARM_EFI_TARGET" ]; then
1666     einfo "Adjusting grub.cfg for successful boot sequence."
1667     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1668   fi
1669
1670   # workaround for Debian bug #918590 with lvm + udev:
1671   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1672   try_umount 3 "${MNTPOINT}"/run/udev
1673
1674   try_umount 3 "${MNTPOINT}"/proc
1675   try_umount 3 "${MNTPOINT}"/sys
1676   try_umount 3 "${MNTPOINT}"/dev/pts
1677   try_umount 3 "${MNTPOINT}"/dev
1678
1679   try_umount 3 "${MNTPOINT}"/boot/efi
1680
1681 }
1682 # }}}
1683
1684 # unmount VM image {{{
1685 umount_target() {
1686   if [ -z "${VIRTUAL}" ] ; then
1687      return 0
1688   fi
1689
1690   try_umount 3 "${MNTPOINT}"/boot/efi
1691
1692   try_umount 3 "${MNTPOINT}"
1693   kpartx -d "${ORIG_TARGET}" >/dev/null
1694   # Workaround for a bug in kpartx which doesn't clean up properly,
1695   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1696   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1697     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1698   fi
1699 }
1700 # }}}
1701
1702 # install main chroot {{{
1703 debootstrap_system() {
1704   if [ "$_opt_nodebootstrap" ]; then
1705      einfo "Skipping debootstrap as requested."
1706      return
1707   fi
1708
1709   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1710     :
1711   else
1712     eerror "Error: $MNTPOINT not mounted, can not continue."
1713     eend 1 ; exit 1
1714   fi
1715
1716   if [ -n "$ISO" ] ; then
1717     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1718     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1719     # shellcheck disable=SC2086
1720     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1721   else
1722     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1723     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1724     # shellcheck disable=SC2086
1725     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1726   fi
1727
1728   if [ $RC -ne 0 ] ; then
1729     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1730       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1731       einfo "Presenting last ten lines of debootstrap.log:"
1732       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1733       einfo "End of debootstrap.log"
1734     fi
1735   fi
1736
1737 }
1738 # }}}
1739
1740 # prepare chroot via chroot-script {{{
1741 preparechroot() {
1742   einfo "Preparing chroot system"
1743
1744   # provide variables to chroot system
1745   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1746   touch "$CHROOT_VARIABLES"
1747   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1748   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1749   [ -n "$ARCH" ]                      && echo "ARCH='${ARCH//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1750   [ -n "$BACKPORTREPOS" ]             && echo "BACKPORTREPOS='${BACKPORTREPOS//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1751   [ -n "$BOOT_APPEND" ]               && echo "BOOT_APPEND='${BOOT_APPEND//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1752   [ -n "$CHROOT_SCRIPTS" ]            && echo "CHROOT_SCRIPTS='${CHROOT_SCRIPTS//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1753   [ -n "$COMPONENTS" ]                && echo "COMPONENTS='${COMPONENTS//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1754   [ -n "$CONFFILES" ]                 && echo "CONFFILES='${CONFFILES//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1755   [ -n "$DEBCONF" ]                   && echo "DEBCONF='${DEBCONF//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1756   [ -n "$DEBIAN_FRONTEND" ]           && echo "DEBIAN_FRONTEND='${DEBIAN_FRONTEND//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1757   [ -n "$DEBOOTSTRAP" ]               && echo "DEBOOTSTRAP='${DEBOOTSTRAP//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1758   [ -n "$DEFAULT_LOCALES" ]           && echo "DEFAULT_LOCALES='${DEFAULT_LOCALES//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1759   [ -n "$DEFAULT_LANGUAGE" ]          && echo "DEFAULT_LANGUAGE='${DEFAULT_LANGUAGE//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1760   [ -n "$EXTRAPACKAGES" ]             && echo "EXTRAPACKAGES='${EXTRAPACKAGES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1761   [ -n "$EFI" ]                       && echo "EFI='${EFI//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1762   [ -n "$FALLBACK_MIRROR" ]           && echo "FALLBACK_MIRROR='${FALLBACK_MIRROR//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1763   [ -n "$FILESYSTEM" ]                && echo "FILESYSTEM='${FILESYSTEM//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1764   [ -n "$FORCE" ]                     && echo "FORCE='${FORCE//\'/\'\\\'\'}'"                                       >> "$CHROOT_VARIABLES"
1765   [ -n "$GRMLREPOS" ]                 && echo "GRMLREPOS='${GRMLREPOS//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1766   [ -n "$GRUB" ]                      && echo "GRUB='${GRUB//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1767   [ -n "$HOSTNAME" ]                  && echo "HOSTNAME='${HOSTNAME//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1768   [ -n "$INITRD" ]                    && echo "INITRD='${INITRD//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1769   [ -n "$INITRD_GENERATOR" ]          && echo "INITRD_GENERATOR='${INITRD_GENERATOR//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1770   [ -n "$INITRD_GENERATOR_OPTS" ]     && echo "INITRD_GENERATOR_OPTS='${INITRD_GENERATOR_OPTS//\'/\'\\\'\'}'"       >> "$CHROOT_VARIABLES"
1771   [ -n "$INSTALL_NOTES" ]             && echo "INSTALL_NOTES='${INSTALL_NOTES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1772   [ -n "$ISODIR" ]                    && echo "ISODIR='${ISO//\'/\'\\\'\'}'"                                        >> "$CHROOT_VARIABLES"
1773   [ -n "$ISO" ]                       && echo "ISO='${ISO//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1774   [ -n "$KEEP_SRC_LIST" ]             && echo "KEEP_SRC_LIST='${KEEP_SRC_LIST//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1775   [ -n "$LOCALES" ]                   && echo "LOCALES='${LOCALES//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1776   [ -n "$MIRROR" ]                    && echo "MIRROR='${MIRROR//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1777   [ -n "$MKFS" ]                      && echo "MKFS='${MKFS//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1778   [ -n "$NOPASSWORD" ]                && echo "NOPASSWORD=\"true\""                                                 >> "$CHROOT_VARIABLES"
1779   [ -n "$NOKERNEL" ]                  && echo "NOKERNEL=\"true\""                                                   >> "$CHROOT_VARIABLES"
1780   [ -n "$PACKAGES" ]                  && echo "PACKAGES='${PACKAGES//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1781   [ -n "$POST_SCRIPTS" ]              && echo "POST_SCRIPTS='${POST_SCRIPTS//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1782   [ -n "$PRE_SCRIPTS" ]               && echo "PRE_SCRIPTS='${PRE_SCRIPTS//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1783   [ -n "$RECONFIGURE" ]               && echo "RECONFIGURE='${RECONFIGURE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1784   [ -n "$RELEASE" ]                   && echo "RELEASE='${RELEASE//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1785   [ -n "$RM_APTCACHE" ]               && echo "RM_APTCACHE='${RM_APTCACHE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1786   [ -n "$ROOTPASSWORD" ]              && echo "ROOTPASSWORD='${ROOTPASSWORD//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1787   [ -n "$SCRIPTS" ]                   && echo "SCRIPTS='${SCRIPTS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1788   [ -n "$SECURE" ]                    && echo "SECURE='${SECURE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1789   [ -n "$SELECTED_PARTITIONS" ]       && echo "SELECTED_PARTITIONS='${SELECTED_PARTITIONS//\'/\'\\\'\'}'"           >> "$CHROOT_VARIABLES"
1790   [ -n "$TARGET" ]                    && echo "TARGET='${TARGET//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1791   [ -n "$UPGRADE_SYSTEM" ]            && echo "UPGRADE_SYSTEM='${UPGRADE_SYSTEM//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1792   [ -n "$TARGET_UUID" ]               && echo "TARGET_UUID='${TARGET_UUID//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1793   [ -n "$TIMEZONE" ]                  && echo "TIMEZONE='${TIMEZONE//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1794   [ -n "$TUNE2FS" ]                   && echo "TUNE2FS='${TUNE2FS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1795   [ -n "$VMSIZE" ]                    && echo "VMSIZE='${VMSIZE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1796
1797   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1798   chmod 755 "${MNTPOINT}"/bin/chroot-script
1799   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1800
1801   # make sure we have our files for later use via chroot-script
1802   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1803   # make sure we adjust the configuration variables accordingly:
1804   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1805   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1806   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1807
1808   # install notes:
1809   if [ -n "$INSTALL_NOTES" ] ; then
1810      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1811   fi
1812
1813   # package selection:
1814   if [ "$PACKAGES" = 'yes' ] ; then
1815     PACKAGES_FILE="packages"
1816
1817     if [ "$ARCH" = 'arm64' ]; then
1818       PACKAGES_FILE="packages-arm64"
1819     fi
1820
1821     cp $VERBOSE "${_opt_packages:-$CONFFILES/$PACKAGES_FILE}" \
1822       "${MNTPOINT}/etc/debootstrap/${PACKAGES_FILE}"
1823   fi
1824
1825   # debconf preseeding:
1826   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1827   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1828     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1829
1830   # copy scripts that should be executed inside the chroot:
1831   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1832   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1833     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1834     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1835   }
1836
1837   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1838   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1839
1840   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1841
1842   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1843   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1844
1845   # setup default locales
1846   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1847
1848   # copy any existing files to chroot
1849   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1850   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1851   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1852   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1853   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1854   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1855   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1856
1857   # network setup
1858   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1859
1860 # Include files from /etc/network/interfaces.d when using
1861 # ifupdown v0.7.44 or newer:
1862 #source-directory /etc/network/interfaces.d
1863
1864 auto lo
1865 iface lo inet loopback
1866
1867 allow-hotplug eth0
1868 iface eth0 inet dhcp
1869 "
1870
1871   # add dhcp setting for Predictable Network Interface Names
1872   if [ -x /bin/udevadm ]; then
1873     tmpfile=$(mktemp)
1874     for interface in /sys/class/net/*; do
1875       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1876       # skip virtual devices, like bridges, vboxnet,...
1877       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1878         continue
1879       fi
1880
1881       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1882       # use and stop on first match to have same behavior as udev's link_config_apply()
1883       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1884         if grep -q "${property}" "${tmpfile}" ; then
1885           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1886           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1887 allow-hotplug ${interface}
1888 iface ${interface} inet dhcp
1889 "
1890           break
1891         fi
1892       done
1893     done
1894     rm -f "${tmpfile}"
1895   fi
1896
1897   if [ -n "$NOINTERFACES" ] ; then
1898     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option"
1899   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1900     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1901     mkdir -p "${MNTPOINT}/etc/network"
1902     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1903   elif [ -n "$VIRTUAL" ] ; then
1904     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1905     mkdir -p "${MNTPOINT}/etc/network"
1906     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1907   elif [ -r /etc/network/interfaces ] ; then
1908     einfo "Copying /etc/network/interfaces from host to target system"
1909     mkdir -p "${MNTPOINT}/etc/network"
1910     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1911   else
1912     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1913     mkdir -p "${MNTPOINT}/etc/network"
1914     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1915   fi
1916
1917   # install config file providing some example entries
1918   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1919     mkdir -p "${MNTPOINT}/etc/network"
1920     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1921   fi
1922
1923   if [ -n "${SSHCOPYID}" ] ; then
1924     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-$HOME/.ssh/authorized_keys}
1925     AUTHORIZED_KEYS_TARGET=${AUTHORIZED_KEYS_TARGET:-$MNTPOINT/root/.ssh/}
1926     if ssh-add -L >/dev/null 2>&1 ; then
1927       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1928       mkdir -p "${MNTPOINT}"/root/.ssh
1929       chmod 0700 "${MNTPOINT}"/root/.ssh
1930       if ! ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1931         eerror "Error: executing 'ssh-add -L' failed."
1932         bailout 1
1933       fi
1934     elif [ -f "$AUTHORIZED_KEYS_SOURCE" ]; then
1935       einfo "copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' as requested via --sshcopyid option."
1936       mkdir -p "$AUTHORIZED_KEYS_TARGET"
1937       chmod 0700 "$AUTHORIZED_KEYS_TARGET"
1938       if ! cp "$AUTHORIZED_KEYS_SOURCE" "$AUTHORIZED_KEYS_TARGET" ; then
1939         eerror "Error: copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' failed"
1940         bailout 1
1941       fi
1942     else
1943       eerror "Error: Could not open a connection to your authentication agent or the agent has no identities."
1944       bailout 1
1945     fi
1946   fi
1947
1948   if [ -n "${SSHCOPYAUTH}" ] ; then
1949     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-${HOME}/.ssh/authorized_keys}
1950
1951     if ! [ -f "${AUTHORIZED_KEYS_SOURCE}" ]; then
1952       eerror "Error: could not read '${AUTHORIZED_KEYS_SOURCE}' for setting up SSH key login."
1953       bailout 1
1954     fi
1955
1956     AUTHORIZED_KEYS_TARGET="${MNTPOINT}/root/.ssh/"
1957     einfo "Copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' as requested via --sshcopyauth option."
1958     mkdir -p "${AUTHORIZED_KEYS_TARGET}"
1959     chmod 0700 "${AUTHORIZED_KEYS_TARGET}"
1960     if ! cp "${AUTHORIZED_KEYS_SOURCE}" "${AUTHORIZED_KEYS_TARGET}" ; then
1961       eerror "Error: copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' failed."
1962       bailout 1
1963     fi
1964   fi
1965
1966   if [ -d /run/udev ] ; then
1967     einfo "Setting up bind-mount /run/udev"
1968     mkdir -p "${MNTPOINT}"/run/udev
1969     mount --bind /run/udev "${MNTPOINT}"/run/udev
1970   fi
1971 }
1972 # }}}
1973
1974 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1975 execute_pre_scripts() {
1976   # make sure hostname is set even before chroot-script get executed
1977   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1978
1979   # make sure we have $MNTPOINT available for our scripts
1980   export MNTPOINT
1981
1982   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1983     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
1984     for script in "${pre_scripts}"/* ; do
1985       if [ -x "$script" ] ; then
1986         einfo "Executing pre-script $script"
1987         "$script"
1988       fi
1989     done
1990   fi
1991 }
1992 # }}}
1993
1994 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
1995 execute_post_scripts() {
1996   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
1997   export MNTPOINT
1998   export TARGET_HOSTNAME=$HOSTNAME
1999
2000   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
2001     # legacy support for /etc/debootstrap/scripts/
2002     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
2003     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
2004   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
2005     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
2006   fi
2007
2008   if [ -n "$post_scripts" ] ; then
2009     for script in "${post_scripts}"/* ; do
2010       if [ -x "$script" ] ; then
2011         einfo "Executing post-script $script"
2012         "$script"
2013       fi
2014     done
2015   fi
2016 }
2017 # }}}
2018
2019 # unmount mountpoint {{{
2020 try_umount() {
2021   local tries=$1
2022   local mountpoint="$2"
2023
2024   if ! mountpoint "$mountpoint" &>/dev/null ; then
2025     return 0
2026   fi
2027
2028   for (( try=1; try<=tries; try++ )); do
2029     if [[ ${try} -eq ${tries} ]]; then
2030       # Last time, show errors this time
2031       umount "${mountpoint}" && return 0
2032     else
2033       # Not last time, hide errors until fatal
2034       if umount "${mountpoint}" 2>/dev/null ; then
2035         return 0
2036       else
2037         sleep 1
2038       fi
2039     fi
2040   done
2041   return 1  # Tried enough
2042 }
2043 # }}}
2044
2045 # execute chroot-script {{{
2046 chrootscript() {
2047   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
2048     mount_target
2049   fi
2050
2051   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
2052     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
2053     eend 1
2054   else
2055     einfo "Executing chroot-script now"
2056     mount -t devtmpfs udev "${MNTPOINT}"/dev
2057     mount -t devpts devpts "${MNTPOINT}"/dev/pts
2058     if [ "$DEBUG" = "true" ] ; then
2059       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script
2060     else
2061       chroot "$MNTPOINT" /bin/chroot-script
2062     fi
2063     try_umount 3 "$MNTPOINT"/dev/pts
2064     try_umount 3 "$MNTPOINT"/dev
2065   fi
2066
2067   # finally get rid of chroot-script again, there's no good reason to
2068   # keep it on the installed system
2069   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
2070     einfo "Removing chroot-script again"
2071     rm -f "${MNTPOINT}/bin/chroot-script"
2072   else
2073     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
2074   fi
2075 }
2076 # }}}
2077
2078 # unmount $MNTPOINT {{{
2079 umount_chroot() {
2080
2081   # display installation notes:
2082   if [ -n "$INSTALL_NOTES" ] ; then
2083      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
2084   fi
2085
2086   if [ -n "$ISODIR" ] ; then
2087      einfo "Unmount $MNTPOINT/$ISODIR"
2088      try_umount 3 "$MNTPOINT/$ISODIR"
2089   fi
2090
2091   try_umount 3 "${MNTPOINT}"/run/udev
2092
2093   if [ -n "$PARTITION" ] ; then
2094      try_umount 3 "$MNTPOINT"
2095   fi
2096 }
2097 # }}}
2098
2099 # execute filesystem check {{{
2100 fscktool() {
2101  if [ -n "$VIRTUAL" ] ; then
2102    einfo "Skipping filesystem check because we deploy a virtual machine."
2103    return 0
2104  fi
2105
2106  if [ "$FSCK" = 'yes' ] ; then
2107    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
2108    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
2109    "$FSCKTOOL" "$TARGET"
2110  fi
2111 }
2112 # }}}
2113
2114 # get rid of grml-debootstrap config files {{{
2115 remove_configs() {
2116   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
2117     return 0
2118   fi
2119
2120   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
2121     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files."
2122     return 0
2123   fi
2124
2125   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
2126   rm -rf "${MNTPOINT}"/etc/debootstrap/
2127 }
2128 # }}}
2129
2130 # now execute all the functions {{{
2131 for i in format_efi_partition prepare_vm mkfs tunefs \
2132          mount_target mountpoint_to_blockdevice debootstrap_system \
2133          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2134          remove_configs umount_chroot grub_install umount_target fscktool ; do
2135     if stage "${i}" ; then
2136       "$i"
2137       stage "${i}" 'done'
2138       rm -f "${STAGES}/${i}"
2139     fi
2140 done
2141
2142 cleanup
2143 # }}}
2144
2145 # end dialog of autoinstallation {{{
2146 if [ -n "$AUTOINSTALL" ] ; then
2147    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2148 Automatically rebooting in 10 seconds.
2149
2150 Choose Cancel to skip rebooting." 10 60 10 ; then
2151      noeject noprompt reboot
2152   fi
2153 else
2154    einfo "Finished execution of ${PN}. Enjoy your Debian system."
2155 fi
2156 # }}}
2157
2158 ## END OF FILE #################################################################
2159 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2